#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <errno.h>
#include "error.h"
unsigned char errorbuf[1024];

void error(unsigned flags, char * fmt, ...)
{
    va_list ap;
    int     len;

    va_start(ap, fmt);
    errorbuf[sizeof(errorbuf) - 1] = '\0';
    len = vsprintf(errorbuf, fmt, ap);
    fprintf(stderr,"%s\n",errorbuf);
    if ((len > sizeof(errorbuf)) || (errorbuf[sizeof(errorbuf)-1] != '\0')) {
        fprintf(stderr,"Error Buffer overflowed. Terminating.\n");
        exit(-1);
    }
    if (flags & ERROR_STDLIB) {
        if (errno) {
            perror("C Library Error");
        }
    }
}
